/*******************************************************************************
 * Copyright (c) 2006 Cisco Technology, Inc and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Author: Andrew Cheadle, CrossCore Optimization Limited
 *
 * Contributors:
 *     Cisco Technology, Inc - Initial implementation
 *******************************************************************************/

package org.eclipseclp.saros.core.preferences;

import org.eclipse.jface.preference.PreferencePage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

/**
 * @author Andrew Cheadle
 * 
 */
public class SarosPreferencePage extends PreferencePage implements
		IWorkbenchPreferencePage {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.preference.PreferencePage#createContents(org.eclipse.swt.widgets.Composite)
	 */
	protected Control createContents(Composite parent) {
		setDescription(PreferenceMessages
				.getString("ECLiPSeStrings.SarosPreferences")
				+ ":");
		Composite composite = new Composite(parent, SWT.NONE);
		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, true);
		composite.setLayout(new GridLayout());
		composite.setLayoutData(gridData);

		gridData = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
		gridData.grabExcessHorizontalSpace = true;
		Group group = new Group(composite, SWT.NONE);
		group.setText(PreferenceMessages
				.getString("ECLiPSeStrings.CoolbarLaunchAction")); //$NON-NLS-1$ group.setLayout(new GridLayout());
		group.setLayout(new GridLayout());
		group.setLayoutData(gridData);
		launcher = new Button(group, SWT.CHECK);
		launcher.setText(PreferenceMessages
				.getString("ECLiPSeStrings.ECLiPSeLauncher"));
		launcher.setSelection(PreferenceManager.launchActionSelection());
		gridData = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
		gridData.grabExcessHorizontalSpace = true;
		launcher.setLayoutData(gridData);
		return composite;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
	}

	protected void performDefaults() {
		launcher.setSelection(PreferenceManager.launchActionSelectionDefault());
		super.performDefaults();
	}

	public boolean performOk() {
		PreferenceManager.setLaunchActionSelection(launcher.getSelection());
		return true;
	}

	private Button launcher = null;
}
