/*******************************************************************************
 * Copyright (c) 2006 Cisco Technology, Inc and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Author: Andrew Cheadle, CrossCore Optimization Limited
 *
 * Contributors:
 *     Cisco Technology, Inc - Initial implementation
 *******************************************************************************/

package org.eclipseclp.saros.development;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipseclp.saros.core.preferences.PreferenceConstants;

import com.parctechnologies.eclipse.Atom;

public class ECLiPSeFilter implements Cloneable {

	public boolean isAnyPredicateFilter() {
		return anyPredicateFilter;
	}

	public void setAnyPredicateFilter(boolean anyPredicateFilter) {
		this.anyPredicateFilter = anyPredicateFilter;
	}

	public boolean isAnySpiedPredicateFilter() {
		return anySpiedPredicateFilter;
	}

	public void setAnySpiedPredicateFilter(boolean anySpiedPredicateFilter) {
		this.anySpiedPredicateFilter = anySpiedPredicateFilter;
	}

	public String getCallingModuleFilter() {
		return callingModuleFilter;
	}

	public void setCallingModuleFilter(String callingModuleFilter) {
		this.callingModuleFilter = callingModuleFilter;
	}

	public boolean isCallPortFilter() {
		return callPortFilter;
	}

	public void setCallPortFilter(boolean callPortFilter) {
		this.callPortFilter = callPortFilter;
	}

	public int getConditionCounterFilter() {
		return conditionCounterFilter;
	}

	public void setConditionCounterFilter(int conditionCounterFilter) {
		this.conditionCounterFilter = conditionCounterFilter;
	}

	public String getConditionFilter() {
		return conditionFilter;
	}

	public void setConditionFilter(String conditionFilter) {
		this.conditionFilter = conditionFilter;
	}

	public String getDefiningModuleFilter() {
		return definingModuleFilter;
	}

	public void setDefiningModuleFilter(String definingModuleFilter) {
		this.definingModuleFilter = definingModuleFilter;
	}

	public boolean isDelayPortFilter() {
		return delayPortFilter;
	}

	public void setDelayPortFilter(boolean delayPortFilter) {
		this.delayPortFilter = delayPortFilter;
	}

	public boolean isElsePortFilter() {
		return elsePortFilter;
	}

	public void setElsePortFilter(boolean elsePortFilter) {
		this.elsePortFilter = elsePortFilter;
	}

	public boolean isExitPortFilter() {
		return exitPortFilter;
	}

	public void setExitPortFilter(boolean exitPortFilter) {
		this.exitPortFilter = exitPortFilter;
	}

	public boolean isFailPortFilter() {
		return failPortFilter;
	}

	public void setFailPortFilter(boolean failPortFilter) {
		this.failPortFilter = failPortFilter;
	}

	public int getFromDepthFilter() {
		return fromDepthFilter;
	}

	public void setFromDepthFilter(int fromDepthFilter) {
		this.fromDepthFilter = fromDepthFilter;
	}

	public int getFromInvocationFilter() {
		return fromInvocationFilter;
	}

	public void setFromInvocationFilter(int fromInvocationFilter) {
		this.fromInvocationFilter = fromInvocationFilter;
	}

	public String getGoalTemplateFilter() {
		return goalTemplateFilter;
	}

	public void setGoalTemplateFilter(String goalTemplateFilter) {
		this.goalTemplateFilter = goalTemplateFilter;
	}

	public boolean isLeavePortFilter() {
		return leavePortFilter;
	}

	public void setLeavePortFilter(boolean leavePortFilter) {
		this.leavePortFilter = leavePortFilter;
	}

	public boolean isModifyPortFilter() {
		return modifyPortFilter;
	}

	public void setModifyPortFilter(boolean modifyPortFilter) {
		this.modifyPortFilter = modifyPortFilter;
	}

	public boolean isNextPortFilter() {
		return nextPortFilter;
	}

	public void setNextPortFilter(boolean nextPortFilter) {
		this.nextPortFilter = nextPortFilter;
	}

	public boolean isRedoPortFilter() {
		return redoPortFilter;
	}

	public void setRedoPortFilter(boolean redoPortFilter) {
		this.redoPortFilter = redoPortFilter;
	}

	public boolean isResumePortFilter() {
		return resumePortFilter;
	}

	public void setResumePortFilter(boolean resumePortFilter) {
		this.resumePortFilter = resumePortFilter;
	}

	public boolean isSpecificPredicateInstanceFilter() {
		return specificPredicateInstanceFilter;
	}

	public void setSpecificPredicateInstanceFilter(
			boolean specificPredicateInstanceFilter) {
		this.specificPredicateInstanceFilter = specificPredicateInstanceFilter;
	}

	public boolean isSpytermPortFilter() {
		return spytermPortFilter;
	}

	public void setSpytermPortFilter(boolean spytermPortFilter) {
		this.spytermPortFilter = spytermPortFilter;
	}

	public boolean isStarExitPortFilter() {
		return starExitPortFilter;
	}

	public void setStarExitPortFilter(boolean starExitPortFilter) {
		this.starExitPortFilter = starExitPortFilter;
	}

	public int getToDepthFilter() {
		return toDepthFilter;
	}

	public void setToDepthFilter(int toDepthFilter) {
		this.toDepthFilter = toDepthFilter;
	}

	public int getToInvocationFilter() {
		return toInvocationFilter;
	}

	public void setToInvocationFilter(int toInvocationFilter) {
		this.toInvocationFilter = toInvocationFilter;
	}

	public boolean isUnifyPortFilter() {
		return unifyPortFilter;
	}

	public void setUnifyPortFilter(boolean unifyPortFilter) {
		this.unifyPortFilter = unifyPortFilter;
	}

	public int getConditionMetCounter() {
		return conditionMetCounter;
	}

	public void setConditionMetCounter(int conditionMetCounter) {
		this.conditionMetCounter = conditionMetCounter;
	}

	public boolean isModified() {
		return modified;
	}

	public void setModified(boolean modified) {
		this.modified = modified;
	}

	public Collection getPortFilters() {
		ArrayList portFilters = new ArrayList();
		if (callPortFilter) {
			portFilters.add(new Atom(PreferenceConstants.call));
		}
		if (exitPortFilter) {
			portFilters.add(new Atom(PreferenceConstants.exit));
		}
		if (starExitPortFilter) {
			portFilters.add(new Atom(PreferenceConstants.starExit));
		}
		if (redoPortFilter) {
			portFilters.add(new Atom(PreferenceConstants.redo));
		}
		if (failPortFilter) {
			portFilters.add(new Atom(PreferenceConstants.fail));
		}
		if (resumePortFilter) {
			portFilters.add(new Atom(PreferenceConstants.resume));
		}
		if (leavePortFilter) {
			portFilters.add(new Atom(PreferenceConstants.leave));
		}
		if (delayPortFilter) {
			portFilters.add(new Atom(PreferenceConstants.delay));
		}
		if (nextPortFilter) {
			portFilters.add(new Atom(PreferenceConstants.next));
		}
		if (unifyPortFilter) {
			portFilters.add(new Atom(PreferenceConstants.unify));
		}
		if (spytermPortFilter) {
			portFilters.add(new Atom(PreferenceConstants.spyterm));
		}
		if (modifyPortFilter) {
			portFilters.add(new Atom(PreferenceConstants.modify));
		}
		if (elsePortFilter) {
			portFilters.add(new Atom(PreferenceConstants.elseString));
		}
		return portFilters;
	}

	public boolean equals(Object object) {
		if (this == object) {
			return true;
		}
		if ((object == null) || (object.getClass() != this.getClass())) {
			return false;
		}
		ECLiPSeFilter filterObject = (ECLiPSeFilter) object;
		return fromInvocationFilter == filterObject.getFromInvocationFilter()
				&& toInvocationFilter == filterObject.getToInvocationFilter()
				&& fromDepthFilter == filterObject.getFromDepthFilter()
				&& toDepthFilter == filterObject.getToDepthFilter()
				&& anyPredicateFilter == filterObject.isAnyPredicateFilter()
				&& anySpiedPredicateFilter == filterObject
						.isAnySpiedPredicateFilter()
				&& specificPredicateInstanceFilter == filterObject
						.isSpecificPredicateInstanceFilter()
				&& definingModuleFilter.equals(filterObject
						.getDefiningModuleFilter())
				&& goalTemplateFilter.equals(filterObject
						.getGoalTemplateFilter())
				&& conditionFilter.equals(filterObject.getConditionFilter())
				&& callingModuleFilter == filterObject.getCallingModuleFilter()
				&& conditionCounterFilter == filterObject
						.getConditionCounterFilter()
				&& callPortFilter == filterObject.isCallPortFilter()
				&& exitPortFilter == filterObject.isExitPortFilter()
				&& starExitPortFilter == filterObject.isStarExitPortFilter()
				&& redoPortFilter == filterObject.isRedoPortFilter()
				&& failPortFilter == filterObject.isFailPortFilter()
				&& resumePortFilter == filterObject.isResumePortFilter()
				&& leavePortFilter == filterObject.isLeavePortFilter()
				&& delayPortFilter == filterObject.isDelayPortFilter()
				&& nextPortFilter == filterObject.isNextPortFilter()
				&& unifyPortFilter == filterObject.isUnifyPortFilter()
				&& spytermPortFilter == filterObject.isSpytermPortFilter()
				&& modifyPortFilter == filterObject.isModifyPortFilter()
				&& elsePortFilter == filterObject.isElsePortFilter();
	}

	public int hashCode() {
		int hash = 3;
		hash = 17 * hash + fromInvocationFilter;
		hash = 17 * hash + fromDepthFilter;
		hash = 17 * hash + (anyPredicateFilter ? 1 : 0);
		hash = 17 * hash + (anySpiedPredicateFilter ? 1 : 0);
		hash = 17 * hash + (specificPredicateInstanceFilter ? 1 : 0);
		hash = 17 * hash + definingModuleFilter.hashCode();
		hash = 17 * hash + goalTemplateFilter.hashCode();
		hash = 17 * hash + conditionFilter.hashCode();
		hash = 17 * hash + callingModuleFilter.hashCode();
		hash = 17 * hash + conditionCounterFilter;
		hash = 17 * hash + (callPortFilter ? 1 : 0);
		hash = 17 * hash + (exitPortFilter ? 1 : 0);
		hash = 17 * hash + (starExitPortFilter ? 1 : 0);
		hash = 17 * hash + (redoPortFilter ? 1 : 0);
		hash = 17 * hash + (failPortFilter ? 1 : 0);
		hash = 17 * hash + (resumePortFilter ? 1 : 0);
		hash = 17 * hash + (leavePortFilter ? 1 : 0);
		hash = 17 * hash + (delayPortFilter ? 1 : 0);
		hash = 17 * hash + (nextPortFilter ? 1 : 0);
		hash = 17 * hash + (unifyPortFilter ? 1 : 0);
		hash = 17 * hash + (spytermPortFilter ? 1 : 0);
		hash = 17 * hash + (modifyPortFilter ? 1 : 0);
		hash = 17 * hash + (elsePortFilter ? 1 : 0);

		// Do these two last
		return hash + toInvocationFilter + toDepthFilter;
	}

	public Object clone() throws CloneNotSupportedException {
		ECLiPSeFilter filter = (ECLiPSeFilter) super.clone();

		return filter;
	}

	private int fromInvocationFilter = 0;

	private int toInvocationFilter = 99999999;

	private int fromDepthFilter = 0;

	private int toDepthFilter = 99999999;

	private boolean anyPredicateFilter = true;

	private boolean anySpiedPredicateFilter = false;

	private boolean specificPredicateInstanceFilter = false;

	private String definingModuleFilter = "";

	private String goalTemplateFilter = "";

	private String conditionFilter = "";

	private String callingModuleFilter = "";

	private int conditionCounterFilter = 1;

	private boolean callPortFilter = true;

	private boolean exitPortFilter = true;

	private boolean starExitPortFilter = true;

	private boolean redoPortFilter = true;

	private boolean failPortFilter = true;

	private boolean resumePortFilter = true;

	private boolean leavePortFilter = true;

	private boolean delayPortFilter = true;

	private boolean nextPortFilter = true;

	private boolean unifyPortFilter = true;

	private boolean spytermPortFilter = true;

	private boolean modifyPortFilter = true;

	private boolean elsePortFilter = true;

	private int conditionMetCounter = 0; // Don't include in equals() and

	private boolean modified = false; // hashcode()
}