/*******************************************************************************
 * Copyright (c) 2006 Cisco Technology, Inc and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Author: Andrew Cheadle, CrossCore Optimization Limited
 *
 * Contributors:
 *     Cisco Technology, Inc - Initial implementation
 *******************************************************************************/

package org.eclipseclp.saros.runtime;

import com.parctechnologies.eclipse.CompoundTerm;

public class AsynchronousRPC {

	public AsynchronousRPC(CompoundTerm command, String message) {
		this.command = command;
		this.message = message;
		this.successContinuation = null;
		this.failureContinuation = null;
	}

	public AsynchronousRPC(CompoundTerm command, String message,
			AsynchronousRPCresult successContinuation,
			Runnable failureContinuation) {
		this.command = command;
		this.message = message;
		this.successContinuation = successContinuation;
		this.failureContinuation = failureContinuation;
	}

	public CompoundTerm getCommand() {
		return command;
	}

	public void setCommand(CompoundTerm command) {
		this.command = command;
	}

	public Runnable getFailureContinuation() {
		return failureContinuation;
	}

	public void setFailureContinuation(Runnable failureContinuation) {
		this.failureContinuation = failureContinuation;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public AsynchronousRPCresult getSuccessContinuation() {
		return successContinuation;
	}

	public void setSuccessContinuation(AsynchronousRPCresult successContinuation) {
		this.successContinuation = successContinuation;
	}

	private CompoundTerm command = null;

	private String message = null;

	private AsynchronousRPCresult successContinuation = null;

	private Runnable failureContinuation = null;
}
